AWSTemplateFormatVersion: 2010-09-09
Description: Launch Highly Available Active/Passive FortiProxy-VM cluster in a new VPC
Metadata:
  'AWS::CloudFormation::Interface':
    ParameterGroups:
      - Label:
          default: VPC Configuration
        Parameters:
          - VPCCIDR
          - PublicSubnet
          - PublicSubnetRouterIP
          - PrivateSubnet
          - PrivateSubnetRouterIP
      - Label:
          default: FortiProxy Instance Configuration
        Parameters:
          - AZForFXP
          - FXPInstanceType
          - FortiProxyVersion
          - LicenseType
          - CIDRForFXPccess
          - KeyPair
      - Label:
          default: Contact
        Parameters:
          - EmailNotification
    ParameterLabels:
      FortiProxyOSVersion:
        default: FotiOS Version
Parameters:
  VPCCIDR:
    Type: String
    Default: 10.0.0.0/16
    Description: Enter the VPC CIDR that you are using
  AZForFXP:
    Type: 'AWS::EC2::AvailabilityZone::Name'
    Description: Select the first AZ for FortiProxyA
  PublicSubnet:
    Type: String
    Default: 10.0.1.0/24
    Description: Provide a network CIDR for the Public Subnet1
  PublicSubnetRouterIP:
    Type: String
    Default: 10.0.1.1
    Description: Provide the IP of the gateway for the public subnet1
  PrivateSubnet:
    Type: String
    Default: 10.0.2.0/24
    Description: Provide a network CIDR for the private subnet1
  PrivateSubnetRouterIP:
    Type: String
    Default: 10.0.2.1
    Description: Provide the IP of the gateway for the private subnet1
  FXPInstanceType:
    Type: String
    Default: c5.xlarge
    Description: Select the instance type for the FortiProxys
    AllowedValues:
      - c5.large
      - c5.xlarge
      - c5.2xlarge
      - c5.4xlarge
      - c5.9xlarge
      - m5.large
      - m5.xlarge
      - m5.2xlarge
      - m5.4xlarge
      - m5.9xlarge
  FortiProxyVersion:
    Type: String
    Default: 7.6.x
    Description: Select the verion of FortiProxyOS to use (latest GA AMI will be used)
    AllowedValues:
      - 7.0.x
      - 7.2.x
      - 7.4.x
      - 7.6.x
  LicenseType:
    Type: String
    Description: Select the license type for the FortiProxys
    AllowedValues:
      - BYOL
  CIDRForFXPccess:
    Type: String
    Default: 0.0.0.0/0
    Description: Enter the CIDR from which FortiProxy instances need to be accessed from
  KeyPair:
    Type: 'AWS::EC2::KeyPair::KeyName'
    Description: Select the keypair for the FortiProxys
  EmailNotification:
    Type: String
    Default: admin@example.com
    Description: >-
      Provide an email address to receive notifications when the CloudWatch
      Failover Alarm is triggered
Mappings:
  FortiProxyAMISearchString:
    7.0.x:
      BYOL: FortiProxy-AWS *v7.0.**|7o0pk87hw95asmwl3610sidil
    7.2.x:
      BYOL: FortiProxy-AWS *v7.2.**|7o0pk87hw95asmwl3610sidil
    7.4.x:
      BYOL: FortiProxy-AWS *7.4.**|7o0pk87hw95asmwl3610sidil
    7.6.x:
      BYOL: FortiProxy-AWS *7.6.**|7o0pk87hw95asmwl3610sidil
Conditions: {}
Resources:
  VPCID:
    Properties:
      CidrBlock: !Ref VPCCIDR
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - VPCID
    Type: 'AWS::EC2::VPC'
  InstanceRole:
    Type: 'AWS::IAM::Role'
    Properties:
      AssumeRolePolicyDocument:
        Version: 2012-10-17
        Statement:
          - Effect: Allow
            Principal:
              Service:
                - ec2.amazonaws.com
            Action:
              - 'sts:AssumeRole'
      Path: /
      Policies:
        - PolicyName: ApplicationPolicy
          PolicyDocument:
            Version: 2012-10-17
            Statement:
              - Effect: Allow
                Action:
                  - 'ec2:Describe*'
                  - 'ec2:AssociateAddress'
                  - 'ec2:AssignPrivateIpAddresses'
                  - 'ec2:UnassignPrivateIpAddresses'
                  - 'ec2:ReplaceRoute'
                  - 's3:GetObject'
                Resource: '*'
  InstanceProfile:
    Type: 'AWS::IAM::InstanceProfile'
    Properties:
      Path: /
      Roles:
        - !Ref InstanceRole
  PrivateSubnetA:
    Properties:
      AvailabilityZone: !Ref AZForFXP
      CidrBlock: !Ref PrivateSubnet
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - PrivateSubnet
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::Subnet'
  PublicSubnetA:
    Properties:
      AvailabilityZone: !Ref AZForFXP
      CidrBlock: !Ref PublicSubnet
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - PublicSubnet
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::Subnet'
  AttachGateway:
    Properties:
      InternetGatewayId: !Ref InternetGateway
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::VPCGatewayAttachment'
  InternetGateway:
    Properties:
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - IGW
    Type: 'AWS::EC2::InternetGateway'
  PublicDefaultRoute:
    DependsOn: AttachGateway
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref InternetGateway
      RouteTableId: !Ref RouteTable
    Type: 'AWS::EC2::Route'
  RouteTable:
    Properties:
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - PublicRoute
      VpcId: !Ref VPCID
    Type: 'AWS::EC2::RouteTable'
  FXPSecGrpBase:
    Type: 'AWS::EC2::SecurityGroup'
    Properties:
      VpcId: !Ref VPCID
      GroupDescription: FXPSecGrp
      SecurityGroupIngress:
        - Description: Allow remote access to FXP
          IpProtocol: '-1'
          FromPort: 0
          ToPort: 65535
          CidrIp: !Ref CIDRForFXPccess
        - Description: Allow local VPC access to FXP
          IpProtocol: '-1'
          FromPort: 0
          ToPort: 65535
          CidrIp: !Ref VPCCIDR
  FXPSecGrpFXPRule:
    Type: 'AWS::EC2::SecurityGroupIngress'
    Properties:
      GroupId: !Ref FXPSecGrpBase
      Description: Allow FXPs to access each other
      IpProtocol: '-1'
      FromPort: 0
      ToPort: 65535
      SourceSecurityGroupId: !Ref FXPSecGrpBase
  FXP:
    Type: 'AWS::EC2::Instance'
    Properties:
      ImageId: !GetAtt RunImageFunction.ami
      InstanceType: !Ref FXPInstanceType
      IamInstanceProfile: !Ref InstanceProfile
      KeyName: !Ref KeyPair
      NetworkInterfaces:
        - NetworkInterfaceId: !Ref FXPENI0
          DeviceIndex: '0'
        - NetworkInterfaceId: !Ref FXPENI1
          DeviceIndex: '1'
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - '-FXP'
      UserData: !Base64 
        'Fn::Join':
          - |+

          - - config system vdom-exception
            - edit 0
            - set object router.static
            - next
            - edit 0
            - set object system.interface
            - end
            - config system global
            - set hostname FXP
            - end
            - config system interface
            - edit port1
            - set alias public
            - set mode static
            - !Join 
              - ''
              - - 'set ip '
                - !GetAtt 
                  - FXPENI0
                  - PrimaryPrivateIpAddress
                - /
                - !Select 
                  - '1'
                  - !Split 
                    - /
                    - !Ref PublicSubnet
            - set allowaccess ping https ssh
            - set mtu-override enable
            - set mtu 9001
            - next
            - edit port2
            - set alias private
            - set mode static
            - !Join 
              - ''
              - - 'set ip '
                - !GetAtt 
                  - FXPENI1
                  - PrimaryPrivateIpAddress
                - /
                - !Select 
                  - '1'
                  - !Split 
                    - /
                    - !Ref PrivateSubnet
            - set allowaccess ping https ssh
            - set mtu-override enable
            - set mtu 9001
            - next
            - end
            - config router static
            - edit 1
            - set device port1
            - !Join 
              - ''
              - - 'set gateway '
                - !Ref PublicSubnetRouterIP
            - next
            - edit 2
            - !Join 
              - ''
              - - 'set dst '
                - !Ref VPCCIDR
            - set device port2
            - !Join 
              - ''
              - - 'set gateway '
                - !Ref PrivateSubnetRouterIP
            - next
            - end
            - config firewall policy
            - edit 1
            - set name outbound-all
            - set srcintf port2
            - set dstintf port1
            - set srcaddr all
            - set dstaddr all
            - set action accept
            - set schedule always
            - set service ALL
            - set logtraffic all
            - set nat enable
            - next
            - end
  FXPENI0:
    Type: 'AWS::EC2::NetworkInterface'
    Properties:
      Description: port1
      GroupSet:
        - !Ref FXPSecGrpBase
      SourceDestCheck: false
      SubnetId: !Ref PublicSubnetA
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - FXPENI0
        - Key: Interface
          Value: eth0
  FXPENI1:
    Type: 'AWS::EC2::NetworkInterface'
    Properties:
      Description: port2
      GroupSet:
        - !Ref FXPSecGrpBase
      SourceDestCheck: false
      SubnetId: !Ref PrivateSubnetA
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - FXPENI1
  ClusterEIP:
    Type: 'AWS::EC2::EIP'
    Properties:
      Domain: vpc
    DependsOn: FXP
  FXPMgmtEIP:
    Type: 'AWS::EC2::EIP'
    Properties:
      Domain: vpc
    DependsOn: FXP
  ClusterAEIPASSOCIATION:
    Type: 'AWS::EC2::EIPAssociation'
    Properties:
      AllocationId: !GetAtt 
        - ClusterEIP
        - AllocationId
      NetworkInterfaceId: !Ref FXPENI0
  PrivateRouteTable:
    Type: 'AWS::EC2::RouteTable'
    Properties:
      VpcId: !Ref VPCID
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - '-PrivateRouteTable'
  DefaultRoute:
    Type: 'AWS::EC2::Route'
    Properties:
      RouteTableId: !Ref PrivateRouteTable
      DestinationCidrBlock: 0.0.0.0/0
      NetworkInterfaceId: !Ref FXPENI1
  AZ1SubnetRouteTableAssociation:
    Type: 'AWS::EC2::SubnetRouteTableAssociation'
    Properties:
      SubnetId: !Ref PrivateSubnetA
      RouteTableId: !Ref PrivateRouteTable
  SubnetRouteTableAssociation1:
    Properties:
      RouteTableId: !Ref RouteTable
      SubnetId: !Ref PublicSubnetA
    Type: 'AWS::EC2::SubnetRouteTableAssociation'
  S3Endpoint:
    Type: 'AWS::EC2::VPCEndpoint'
    Properties:
      PolicyDocument:
        Version: 2012-10-17
        Statement:
          - Effect: Allow
            Principal: '*'
            Action:
              - 's3:*'
            Resource:
              - '*'
      RouteTableIds:
        - !Ref RouteTable
      ServiceName: !Join 
        - ''
        - - com.amazonaws.
          - !Ref 'AWS::Region'
          - .s3
      VpcId: !Ref VPCID
  CloudwatchAlarmFXP:
    Type: 'AWS::CloudWatch::Alarm'
    Properties:
      ActionsEnabled: true
      AlarmActions:
        - !Join 
          - ''
          - - 'arn:aws:automate:'
            - !Ref 'AWS::Region'
            - ':ec2:recover'
      AlarmDescription: Cloudwatch alarm to monitor instances status
      AlarmName: !Join 
        - ''
        - - !Ref 'AWS::StackName'
          - '-CWAlarmFXP'
      ComparisonOperator: GreaterThanThreshold
      Dimensions:
        - Name: InstanceId
          Value: !Ref FXP
      EvaluationPeriods: 3
      MetricName: StatusCheckFailed_System
      Namespace: AWS/EC2
      Period: 300
      Statistic: Minimum
      Threshold: 0
  LambdaRole:
    Type: AWS::IAM::Role
    Properties:
      AssumeRolePolicyDocument:
        Version: '2012-10-17'
        Statement:
          - Effect: Allow
            Principal:
              Service:
                - lambda.amazonaws.com
            Action:
              - sts:AssumeRole
      Path: /
      Policies:
        - PolicyName: S3AccessRole
          PolicyDocument:
            Version: '2012-10-17'
            Statement:
              - Effect: Allow
                Action:
                  - ec2:DescribeImages
                  - s3:PutObject
                Resource: '*'
              - Effect: Allow
                Action:
                  - logs:*
                Resource: '*'
  ImageFunction:
    Type: AWS::Lambda::Function
    Properties:
      Code:
        ZipFile: !Join
          - |+

          - - import boto3
            - import cfnresponse
            - import logging
            - import json
            - logger = logging.getLogger()
            - logger.setLevel(logging.INFO)
            - client = boto3.client('ec2')
            - ''
            - 'def handler(event, context):'
            - '    if event[''RequestType''] == ''Create'':'
            - '        logger.info(''<-- event received: {}''.format(json.dumps(event)))'
            - '        searchString = event[''ResourceProperties''][''SearchString'']'
            - '        productCode =  event[''ResourceProperties''][''ProductCode'']'
            - '    else:'
            - '        responseData = {''msg'':''200''}'
            - '        cfnresponse.send(event, context, cfnresponse.SUCCESS, responseData)'
            - '        return None'
            - ''
            - '    try:'
            - '        resp = client.describe_images('
            - '            Filters=[{''Name'': ''name'', ''Values'': [searchString]}, {''Name'': ''product-code'', ''Values'': [productCode]}],'
            - '            Owners=[''aws-marketplace'']'
            - '        )'
            - '    except Exception as error:'
            - '        logger.error(''<--!! Exception: {}''.format(error))'
            - '        responseData = {''msg'':''Exception: {}''.format(error)}'
            - '        cfnresponse.send(event, context, cfnresponse.FAILED, responseData)'
            - ''
            - '    if resp[''ResponseMetadata''][''HTTPStatusCode''] == 200 and resp[''Images''] != []:'
            - '        ami_dict = {}'
            - '        ami_list = []'
            - '        for entry in resp[''Images'']:'
            - '            key = entry[''CreationDate'']'
            - '            ami_dict[key] = entry[''ImageId'']'
            - '        ami_list = sorted(ami_dict, reverse = True)'
            - '        logger.info(''--> found latest AMI: {}, {}, {} {}''.format(ami_dict[ami_list[0]], ami_list[0], searchString, productCode))'
            - '        responseData = {''ami'': ami_dict[ami_list[0]]}'
            - '        cfnresponse.send(event, context, cfnresponse.SUCCESS, responseData)'
            - '    else:'
            - '        logger.error(''!!--> Unable to find AMI {} {} in describe_images response! {}''.format(searchString, productCode, resp))'
            - '        responseData = {''msg'':''Unable to find AMI {} {} in describe_images response! {}''.format(searchString, productCode,resp)}'
            - '        cfnresponse.send(event, context, cfnresponse.FAILED, responseData)'
            - ''
      Role: !GetAtt LambdaRole.Arn
      Timeout: 120
      Handler: index.handler
      Runtime: python3.9
      MemorySize: 128
  RunImageFunction:
    Type: Custom::ImageFunction
    Properties:
      ServiceToken: !GetAtt ImageFunction.Arn
      SearchString: !Select
        - '0'
        - !Split
          - '|'
          - !FindInMap
            - FortiProxyAMISearchString
            - !Ref FortiProxyVersion
            - !Ref LicenseType
      ProductCode: !Select
        - '1'
        - !Split
          - '|'
          - !FindInMap
            - FortiProxyAMISearchString
            - !Ref FortiProxyVersion
            - !Ref LicenseType
Outputs:
  FXPURL:
    Value: !Join 
      - ''
      - - 'https://'
        - !Ref FXPMgmtEIP
    Description: URL to access FortiProxyA
  FXPUsername:
    Value: admin
    Description: Username to access FortiProxys
  FXPPassword:
    Value: !Ref FXP
    Description: Password to access FortiProxyA